function idx = assignClosestCentroids(X, centroids)
% assignClosestCentroid computes the centroid memberships for 
% every example 


%Initialize values
% Set K
K = size(centroids, 1);
idx = zeros(size(X,1), 1);



distance = zeros(size(X,1),K);
%Find the distance from each point to the initialized centroids
for i = 1:K
    diffs = bsxfun(@minus, X, centroids(i,:));
    distance(:,i) = sum(diffs.^2, 2);
    
end

% index the column which holds the minimum distance.
[fodder index] = min(distance, [], 2);

idx = index;


end
