%Clears everything as an initialization of the program
clc, clear, close('all') 
tic %for timing the program


%Main program for running the K-means clustering.

%initiate counting of cycles
cycles = 0;

%======== User input======================
%Number of clusters
K = 4;
%Total of random initialized loops
totalloops = 100;
%Number of iterations to find the optimal cluster per loop
max_iterat = 40;
%Choose wether or not to count cycles; 1 = yes
countcycles = 1;


%Load values 
%forstetall = loadforstetall();
load('../flowdata/CDF_500space.mat');
load('../flowdata/PDF_500space.mat');
load('../flowdata/per_sensor_data.mat');
load('../flowdata/per_sensor_data_sorted.mat');
load('../flowdata/Uslug_data.mat');
load('../flowdata/FFT_data.mat');
load('../flowdata/sensor_shift_diff.mat');
X = [sensor1cdf500];
m = size(X,1);
n = size(X,2);

%Standard score, if wanted. Applicable when using
%data of different sizes or nature
[X, mu, sigma] = zscore(X);

%%
%============== The K-means algorithm ==============
%Apply K-means a number of times to avoid local 
%minima and find global minima 
for i = 1 : totalloops

    %Randomly initialize centroids
    initial_centroids = randomInit(X, K);
    
    
    %Run the kmeans algorith for this set of initialization centroids
    [centroids, idx] = runkmeans(X, initial_centroids, max_iterat);
    
    %Remember the centroids and assignments for each run
    centroidsroll(i,:) = centroids(:)';
    idxroll(:,i) = idx;
    
    
    %compute the distortion (cost function for k-means)
    J(i) = computedist(X, centroids, idx);

    
    if countcycles == 1
        cycles = cycles + 1
    else
    end
    
end




%Find minimum value for distortion, and it's index
[distortion, index] = min(J);
least_dist_idx = idxroll(:,index);
least_dist_centroids = reshape(centroidsroll(index,:),[K,n]);

distortion;

%plot the measurements in an Uls Ugs diagram and show the assigned
%centroids.
plotKmeans(least_dist_idx,K);
toc