function plotKmeans(idx, K)

figure; hold on;
Mrkr = '+oxsd^v><ph';
load('../flowdata/Ugs_Uls_speeds.mat');
for i = 1:K
    
    cluster = find(idx==i);
    plot(Ugs_Uls_speeds(cluster, 1), ...
        Ugs_Uls_speeds(cluster, 2), Mrkr(i), ...
        'LineWidth', 2.5, 'MarkerSize', 9)
    
end

xlabel('Ugs [m/s]', 'FontSize', 25)
ylabel('Uls [m/s]', 'FontSize', 25)
set(gca, 'xscale', 'log')
set(gca, 'yscale', 'log')
set(gca, 'XLim', [0.1 10])
set(gca, 'YLim', [0.1 10])
set(gca, 'XGrid', 'on')
set(gca, 'XMinorGrid', 'on')
set(gca, 'YGrid', 'on')
set(gca, 'YMinorGrid', 'on')
set(gca, 'GridLineStyle', '-')
set(gca, 'fontsize', 18)
set(gca, 'GridAlpha', 0.50)
set(gca, 'MinorGridAlpha', 0.40)

for i = 1:K
    legendnames{i} = ['Cluster' num2str(i)];
end
legenden = legend('show', legendnames);
set(legenden, 'FontSize', 18);

hold off;

end