function [centroids idx] = runkmeans(X, initial_centroids, max_iters)

% Each row of X represents an example, and each column of X 
% is a feature of X. runkmeans runs the K-means algorithm on 
% the X matrix, with the given initial centrois, for a given 
% max iterations.

%initializing values
[m n] = size(X);
K = size(initial_centroids, 1);
centroids = initial_centroids;
idx = zeros(m, 1);


for i = 1:max_iters
    
    %Assign the closest centroid for each example in X
    idx = assignClosestCentroid(X, centroids);
    
    
    %Given assignment to centroids, compute new centroids
    centroids = computeCentroids(X, idx, K);
    
end

end