%%
%Initialization and choosing variables
clc, clear, close('all')
tic

%Main program for running the neural network with one hidden layer

%load data features and classifiers.
load('kmeans_id.mat');
load('eeg_id.mat');
%load('../flowdata/forstetall.mat');
load('../flowdata/CDF_500space.mat');
load('../flowdata/PDF_500space.mat');
load('../flowdata/per_sensor_data.mat');
load('../flowdata/per_sensor_data_sorted.mat');
load('../flowdata/Uslug_data.mat');
load('../flowdata/FFT_data.mat');
load('../flowdata/sensor_shift_diff.mat');

%Choose wether to test on train whole set, or random init
% 1 = ramdom init, 0 = train on whole set
random_init = 1;


%X is the data chosen for training the algortihm
X = [sensor1cdf500 Uslug_data];

%y is the identifyer vector containing predetermined
%classification data
y = kmeans_id;
%y = Eeg_id;

%set lambda for regularization
lambda = 1;

%feature normalization, standard score.
%Makes is easier for the weights to adapt.
[X, mu, sigma] = zscore(X);

if random_init == 1
    %randomly chooses training and test data given a fraction
    %to be amount of training data.
    %The randomized index is also extracted for camparison
    [X ,y ,X_test ,y_test, ...
        train_randindex, test_randindex] = nnRandInit(X,y,0.70);
else
    %Train the whole set, then test it on itself
    X_test = X;
    y_test = y;
    test_randindex = [1 : size(X,1)]';
end
%Set the number of learning iterations
learning_iterations = 100;

%set the different layer sizes
input_layer_size = size(X,2);
number_hidden_layer = 50;
num_labels = max(y);




%%
%random initialization
initial_Theta1 = randInitializeWeights(input_layer_size, ...
                        number_hidden_layer);
initial_Theta2 = randInitializeWeights(number_hidden_layer, ...
                        num_labels);

%unroll parameters
initial_nn_params = [initial_Theta1(:); initial_Theta2(:)];




% ======== Training the Neural Network ========

options = optimset('MaxIter', learning_iterations);

costFunction = @(p) nnCostFunction (p, ...
                                    input_layer_size, ...
                                    number_hidden_layer, ...
                                    num_labels, X, y, lambda);
            
[nn_params, cost] = fmincg(costFunction, initial_nn_params, ...
                           options);
                       
Theta1 = reshape(nn_params(1:number_hidden_layer * ...
                            (input_layer_size + 1)), ...
                 number_hidden_layer, (input_layer_size + 1));

Theta2 = reshape(nn_params((1 + (number_hidden_layer * ...
                            (input_layer_size + 1))):end), ...
                            num_labels, (number_hidden_layer + 1));
                        
%%
% =============== Predict using the trained neural network=======                        

pred = predict(Theta1, Theta2, X_test);

Prediction_percentage = mean(double(pred==y_test))*100;

%This plots the test set, and marks the one that
%it failed to identify correctly.
%the index of the missed file is also output
miss = plotNN(pred,num_labels,test_randindex,y_test)
Prediction_percentage


toc
