function [train_X, train_y ...
          test_X, test_y, train_randindex, ...
          test_randindex] = nnRandInit(X,y,trainsize)
%This randomly picks examples for training and test set

%Gets the sizes of the input matrix and vector
[Xm, Xn] = size(X);

%The number of examples used for training
train_amount = round(trainsize*Xm);

%consolidates X and Y for randomization, so that the
%indexes of X and y will remain the same after randperm
allData = [X y];

%Randomizes the index of the data
randomindex = randperm(size(allData, 1));

%gets the randomized data in a train and test set
train_set = allData(randomindex(1:train_amount), :);
test_set = allData(randomindex(train_amount+1:end), :);

%Gets original indexes of the training and test set
train_randindex = randomindex(:,1:train_amount)';
test_randindex = randomindex(:,train_amount+1:end)';

%extracts the X and y values from train and test sets
train_X = train_set(:,1:Xn);
train_y = train_set(:,Xn+1);
test_X = test_set(:,1:Xn);
test_y = test_set(:,Xn+1);

end