function miss = plotKmeans(pred, num_labels, test_randindex, y_test)

figure; hold on;
Mrkr = '+osd^xv><ph';
load('../flowdata/Ugs_Uls_speeds.mat');

Ugs_Uls_speeds_hit = Ugs_Uls_speeds(test_randindex,:);

for i = 1:num_labels
    
    label = find(pred==i);
    plot(Ugs_Uls_speeds_hit(label, 1), ...
        Ugs_Uls_speeds_hit(label, 2), Mrkr(i), ...
        'LineWidth', 2.5, 'MarkerSize', 9)
    
end

miss = test_randindex(pred~=y_test);

plot(Ugs_Uls_speeds(miss,1), ...
    Ugs_Uls_speeds(miss,2), 'xr', 'LineWidth', 2.5, ...
    'MarkerSize', 9)

xlabel('Ugs [m/s]', 'FontSize', 25)
ylabel('Uls [m/s]', 'FontSize', 25)
set(gca, 'xscale', 'log')
set(gca, 'yscale', 'log')
set(gca, 'XLim', [0.1 10])
set(gca, 'YLim', [0.1 10])
set(gca, 'XGrid', 'on')
set(gca, 'XMinorGrid', 'on')
set(gca, 'YGrid', 'on')
set(gca, 'YMinorGrid', 'on')
set(gca, 'GridLineStyle', '-')
set(gca, 'fontsize', 18)
set(gca, 'GridAlpha', 0.50)
set(gca, 'MinorGridAlpha', 0.40)

for i = 1:num_labels
    legendnames{i} = ['Classification' num2str(i)];
end
legenden = legend('show', legendnames);
set(legenden, 'FontSize', 18);

hold off;

end